/*
some code possibly from berlios
some code possibly from deadbeef
some code possibly from firebird
some code possibly from iceepg
some code possibly from peteru
some code possibly from r2d2
some code possibly from simonc
possibly some code from elsewhere ...
*/
/*
Portions of this code may be covered under the GNU General Public License. Any
such code is likely to have been modified, possibly beyond recognition, but is
still covered under this license. All other portions are free from any license.

        Some portions may be:
        Copyright (C) 2005 Simon Capewell, http://tap.berlios.de/
        Copyright (C) 2004-2005 Peter Urbanec. All Rights Reserved. http://tap.berlios.de/
        Copyright (C) 2005 DeadBeef, http://de.geocities.com/deadbeef55/
        Copyright (C) 2005 IceTv Pty Limited, http://www.icetv.com.au/
        Copyright (C) 2005 Tony H, http://tonyspage.dyndns.org/

        This is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        The software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this software; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
    v0.01 - initial release
    v0.02 - added exTAP_EPG_GetNumEvents()
          - removed runningStatus from exTAP_EPG_DeleteEvent()
          - updated for firmware v12.25
    v0.03 - added exTAP_MHEG_Status()
          - added exTAP_GetFirmwareAddress()
          - added exTAP_EPG_Resize()
          - added exTAP_EPG_GetSize()
          - added TAP_Hdd_Move()
    v0.04 - fixed leak int exTAP_EPG_GetSize()
          - fixed bug in hook code trashing $gp when multiple taps active
    v0.05 - added TAP_GetTuner()
          - changed exTAP_CallFirmware() to pass in 11 arguments rather than 4
          - added exTAP_isPatched()
          - added exTAP_MHEG_isPatched()
          - added exTAP_EIT_Schedule()
          - added exTAP_EIT_NowNext()
          - added exTAP_EPG_Stick()
          - added sysid to type_patch/type_hook
          - separated firmware addresses to autogenerated patches.h/patches.c
            support for many firmwares, using generate_patches.exe
    v0.06 - updated for firmware v12.88
          - removed prints (use #define exTAPdebug
          - better error reporting (still more to do)
          - added TAP_Channel_StopMainSub()
          - added TAP_undoc11()
          - added TAP_Channel_SwapMainSub()
          - fixed hooks to support any firmware
          - added exTAP_GetCurrentGenre()
          - added exTAP_GetGenre()
          - added exTAP_CallTap()
          - added exTAP_SendMessage()
    v0.07 - fixed extended event handling
    v0.08 - fixed exTAP_TAP_Load()
          - added fw_enable_tshift
          - added fw_stop_tshift
          - added fw_mheg_disable
          - added fw_ioctl
    v0.09 - added support for more firmwares
          - added multple firmware support for exTAP_EPG_Stick()
    v0.10 - added support for 456:13.26
          - added exTAP_GetPIPPosition()
          - added exTAP_get_afd()
          - added exTAP_update_aspect_ratio()
    v0.11 - updated patches
          - added unique per tapident to hooks
          - fixed exTAP_update_aspect_ratio() for sub channel/radio
          - added exTAP_GetInteractiveStatus()
          - added exTAP_SetInteractiveStatus()
    v0.12 - added fw_get_genre_str
          - added fw_epg_highlighted_event
          - added fw_epg_refresh
    v0.13 - added fw_fChangePlaybackPos
          - added fw_get_channel_info
    v0.14 - added support for 456:13.39
    v0.15 - increased MAX_FIRMWARE_REVISIONS
          - added exTAP_GetTwinkle()
          - added exTAP_SetTwinkle()
          - added exTAP_GetSubtitleStatus()
          - added support for 456:13.40
    v0.16 - added support for 456:13.55, 456:13.55
          - changed structure type_eventtable to default to >12.88 format, and any functions that use it
    v0.17 - added support for 456:13.59
          - added fw_play_info, fw_play_header, fw_rec_info, fw_rec_header
          - added fw_tshift_slot
          - added fw_pcr1_pid;
          - added fw_ts_struct1, fw_ts_struct2
          - added fw_tshift_block_offset
          - added fw_grab_screen_image
    v0.18 - a bit of a reorganisation
          - added support for 456:14.02, 456:14.06/7/8, 457:15.0
          - added option to support dynamic/static patch addresses
          - updated patch generator

todo;
    afd for non-uk
*/
/*
conventions:
return values:
    -ve   = error
    0,+ve = no_error
*/

#include <tap.h>
#include "exTap.h"

#ifdef USE_PATCHES
#include "patches.h"
#endif

#ifdef USE_FIREBIRDLIB
#include "libFirebird.h"
#endif

extern void patch_hook();
//----------------------------------------------------------------------------
word fw_sysid = 0;


dword fw_tap_table = 0;
dword fw_tap_ident = 0;
dword fw_gp = 0;

void *fw_TAP_GetCurrentEvent = 0;
void *fw_TAP_GetSignalLevel = 0;
void *fw_TAP_GetSystemProc = 0;
void *fw_TAP_KbHit = 0;
void *fw_add_task_queue = 0;
void *fw_ioctl = 0;

void *fw_pattern_afd = 0;
void *fw_channel_scale = 0;
void *fw_DbgSi_LoadDmx = 0;
void *fw_display_func = 0;
void *fw_enable_tshift = 0;
void *fw_pattern_epg_highlighted_event = 0;
void *fw_pattern_epg_highlighted_event2 = 0;
void *fw_pattern_epg_refresh = 0;
void *fw_epgstck_patch = 0;
void *fw_event_alloc = 0;
void *fw_event_delete = 0;
void *fw_fChangePlaybackPos = 0;
void *fw_findfirst = 0;
void *fw_get_channel_info = 0;
void *fw_get_genre_str = 0;
void *fw_grab_screen_image = 0;
void *fw_hdd_move = 0;
void *fw_is_recording = 0;
void *fw_key_map_patch = 0;
void *fw_key_map_patch2 = 0;
void *fw_mheg_disable = 0;
void *fw_pattern_mheg_entry = 0;
void *fw_pattern_mheg_entry2 = 0;
void *fw_os_free = 0;
void *fw_pattern_pcr1_pid = 0;
void *fw_process_dsmcc = 0;
void *fw_process_eit = 0;
void *fw_process_tdt = 0;
void *fw_process_tot = 0;
void *fw_pattern_sequence_header = 0;
void *fw_set_wss = 0;
void *fw_shutdown_irq_disable = 0;
void *fw_shutdown_irq_enable = 0;
void *fw_shutdown_task = 0;
void *fw_StartRecord = 0;
void *fw_stop_tshift = 0;
void *fw_tap_load = 0;
void *fw_pattern_tap_load_data1 = 0;
void *fw_pattern_tap_load_data1_2 = 0;
void *fw_pattern_tap_load_data2 = 0;
void *fw_translate_and_display = 0;
void *fw_pattern_ts_struct1 = 0;
void *fw_pattern_ts_struct2 = 0;
void *fw_pattern_tshift_block_offset = 0;
void *fw_pattern_twinkle = 0;
void *fw_utctolocal_time = 0;

//void *fw_pattern_tshift_slot = 0;

dword fw_afd = 0;
char *fw_display_string = 0;
byte *fw_epg_refresh = 0;
type_eventtable *fw_epg_highlighted_event = 0;
dword fw_etc_structure = 0;
type_eventbuffer *fw_event_buffer = 0;
type_eventtable *fw_event_table = 0;
int fw_event_table_size = 0;
dword *fw_ext_function_table = 0;
int fw_max_events = 0;
dword *fw_mheg_entry = 0;
int fw_num_ext_functions = 0;
dword fw_play_info = 0;
dword fw_play_header = 0;
dword fw_rec_info = 0;
dword fw_rec_header = 0;
byte *fw_tshift_slot = 0;
dword *fw_pcr1_pid = 0;
dword fw_sequence_header = 0;
dword *fw_tap_load_data0 = 0;
dword *fw_tap_load_data1 = 0;
dword *fw_tap_load_data2 = 0;
dword fw_ts_struct1 = 0;
dword fw_ts_struct2 = 0;
dword *fw_tshift_block_offset = 0;
word *fw_twinkle = 0;
type_taptime *fw_utc_time = 0;

void *fw_pattern_flash = 0;
void *fw_pattern_timer = 0;
type_flash *fw_flash = 0;
type_timer_block *fw_timer_table = 0;
int fw_timer_table_size = 0;
int fw_max_timers = 0;

type_aspect fw_aspect[2] = {0};
type_aspect last_aspect[2] = {0};


//undocumented tap functions
int   (*TAP_Channel_StopMainSub)(void);             //TAP_Channel_StopMainSub(), returns 1;

//extended tap functions
int   (*TAP_Hdd_ReadSectorDMA)(int mode, word, byte *buffer);
int   (*TAP_Hdd_WriteSectorDMA)(int mode, word, byte *buffer);
void  (*TAP_unknown2)(void);
int   (*TAP_Hdd_unknown3)(int);
byte  (*TAP_GetTuner)(int mainSub);
dword (*TAP_Hdd_Move)(char *from_dir, char *to_dir, char *filename);
int   (*TAP_Osd_unknown20)(dword *);
int   (*TAP_Channel_SwapMainSub)(void);

//----------------------------------------------------------------------------
//non exported functions
int   exTAP_isPatched2(type_patch2 *patch, dword addr, int *index);
int   exTAP_ApplyPatch2(type_patch2 *patch, dword addr, int *id);
int   exTAP_RemovePatch2(type_patch2 *patch, dword addr);
int   exTAP_ApplyPatch3(dword addr, byte *from, byte *to, int length);

//----------------------------------------------------------------------------
int exTAP_Init(void)
{
    int ret;
    type_TAPProcess *TAPProcess;

    //
    //set the firmware addresses
    //
    fw_sysid = *(word*)wSysID;

#ifndef USE_FIREBIRDLIB
//printf("\nnot using FIREBIRDLIB");
#else //USE_FIREBIRDLIB
//printf("\nusing FIREBIRDLIB");
    ret = InitTAPex();
//    TAP_Print("\nInitTAPex(), ret=%x", ret);
    if (ret == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), InitTAPex(), ret=%x", __func__, ret);
#endif //exTAPdebug
        return EXTAPERR_BAD_FIRMWARE;
    }
#endif //USE_FIREBIRDLIB

    //these ones are critical (required)
    //the fw_xxx variables are later used unchecked, so if null, will cause a crash
    ret = init_critical_fw_addresses();
    if (ret < 0) {
        TAP_Print("\n%s(), init_critical_fw_addresses(), ret=%x", __func__, ret);
        goto exit;
    }
#ifdef exTAPdebug
    TAP_Print("\nfw_sysid=%d", fw_sysid);
    TAP_Print("\nfw_tap_ident=%x", fw_tap_ident);
    TAP_Print("\nfw_tap_table=%x", fw_tap_table);
    TAP_Print("\nfw_gp=%x", fw_gp);
    TAP_Print("\nfw_ioctl=%x", fw_ioctl);
    TAP_Print("\nfw_add_task_queue=%x", fw_add_task_queue);
#endif //exTAPdebug

    ret = init_optional_fw_addresses();
//    TAP_Print("\ninit_optional_fw_addresses(), ret=%x", ret);

    TAPProcess = (type_TAPProcess *)(fw_tap_table + ((*(dword *)fw_tap_ident)*32));
    TAP_Channel_StopMainSub = TAPProcess->entryPoints->pTAP_Channel_StopMainSub;
    TAP_Hdd_ReadSectorDMA = TAP_GetSystemProc(oTAP_Hdd_ReadSectorDMA);
    TAP_Hdd_WriteSectorDMA = TAP_GetSystemProc(oTAP_Hdd_WriteSectorDMA);
    TAP_unknown2      = TAP_GetSystemProc(oTAP_unknown2);
    TAP_Hdd_unknown3  = TAP_GetSystemProc(oTAP_Hdd_unknown3);
    TAP_GetTuner      = TAP_GetSystemProc(oTAP_GetTuner);
    TAP_Hdd_Move      = TAP_GetSystemProc(oTAP_Hdd_Move);
    TAP_Osd_unknown20 = TAP_GetSystemProc(oTAP_Osd_unknown20);
    TAP_Channel_SwapMainSub = TAP_GetSystemProc(oTAP_Channel_SwapMainSub);                  //1288 only


    //set the address of tap_ident, tap_table in hook_main()
    patch_hook();

//    TAP_Print("\nend of exTAP_Init()");
    return 0;

exit:
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
    TAP_Print("\n");
#endif
    return EXTAPERR_BAD_FIRMWARE;
}




#define MAX_FIRMWARE_REVISIONS 0x40

dword exTAP_GetFirmwareAddress(type_firmware *firmware)
{
    int i;

    for (i=0; i<MAX_FIRMWARE_REVISIONS; i++) {
//    for (i=0; i<(sizeof(fwlist_tap_ident)/sizeof(type_firmware)); i++) {
        if (firmware[i].sysid == fw_sysid) {
            if (firmware[i].revision > 0) {
                if (firmware[i].revision == _appl_version) {
                    if (firmware[i].address) return firmware[i].address;
                }
            }
        }
        else if (firmware[i].sysid == 0) {
            break;
        }
    }
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
//for(i=0; i<MAX_FIRMWARE_REVISIONS; i++) {
//TAP_Print("\nfirmware[%d].address = %d:%x %08x", i, firmware[i].sysid, firmware[i].revision, firmware[i].address);
//}
#endif
    return 0;
//    return EXTAPERR_BAD_FIRMWARE;
}

//----------------------------------------------------------------------------
/*
for reference, gcc inline requires a numeric register naming convention
$0    0         $t0   8         $s0  16             $t8  24
$at,$1   1      $t1   9         $s1  17             $t9  25
$v0   2         $t2  10         $s2  18             $k0  26
$v1   3         $t3  11         $s3  19             $k1  27
$a0   4         $t4  12         $s4  20             $gp  28
$a1   5         $t5  13         $s5  21             $sp  29
$a2   6         $t6  14         $s6  22         $s8,$fp  30
$a3   7         $t7  15         $s7  23             $ra  31
*/
//what is the order for registers after a0,a1,a2,a3, ... - uses stack
dword exTAP_CallFirmware(void *pFunction, dword p0, dword p1, dword p2, dword p3, dword p4, dword p5, dword p6, dword p7, dword p8, dword p9, dword p10)
{
    // The function has to be implemented in assembler in order to
    // gain full control over register usage.
    // The firmware makes use of the $gp register which contains
    // a different value when running in TAP context.
    __asm__ __volatile__ (
    "addiu   $sp,$sp,0xffc8\n"                            //addiu   $sp,$sp,-0x38
    "sw      $31,0x0030($sp)\n"                           //sw      $ra,0x0014($sp)         save ra
    "sw      $22,0x0034($sp)\n"                           //sw      $s6,0x0018($sp)         save s6

    "or      $15,%0,$00\n"                                //or      $t7,tap_ident,$00       ptr to tap_ident
    "or      $22,%1,$00\n"                                //or      $s6,tap_table,$00       ptr to tap_table

    "or      $08,$00,%2\n"                                //or      $t0,$00,pFunction       beware of the order here ...
    "or      $04,$00,%3\n"                                //or      $a0,$00,p0
    "or      $05,$00,%4\n"                                //or      $a1,$00,p1
    "or      $06,$00,%5\n"                                //or      $a2,$00,p2
    "lw      $07, 0x40+0x14($sp)\n"                       //
    "sw      $07, 0x10($sp)\n"                            //p4
    "lw      $07, 0x40+0x18($sp)\n"                       //
    "sw      $07, 0x14($sp)\n"                            //p5
    "lw      $07, 0x40+0x1c($sp)\n"                       //
    "sw      $07, 0x18($sp)\n"                            //p6
    "lw      $07, 0x40+0x20($sp)\n"                       //
    "sw      $07, 0x1c($sp)\n"                            //p7
    "lw      $07, 0x40+0x24($sp)\n"                       //
    "sw      $07, 0x20($sp)\n"                            //p8
    "lw      $07, 0x40+0x28($sp)\n"                       //
    "sw      $07, 0x24($sp)\n"                            //p9
    "lw      $07, 0x40+0x2c($sp)\n"                       //
    "sw      $07, 0x28($sp)\n"                            //p10

    "lw      $07, 0x40+0x10($sp)\n"                       //$a3     p3

    "lw      $15,0x0000($15)\n"                           //lw      $t7,0x0000($t7)         get tap_ident
    "sll     $15,$15,0x05\n"                              //sll     $t7,$t7,0x05            tap_ident * 32
    "addu    $22,$22,$15\n"                               //addu    $s6,$s6,$t7             offset to this taps tap_table

    "lw      $03,0x0000($22)\n"                           //lw      $v1,0x0000($s6)         get firmware gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             set gp

    "jal     $08\n"                                       //jal     $t0                     call function(p0, p1, p2, p3)

    "lw      $03,0x0004($22)\n"                           //lw      $v1,0x0004($s6)         get tap gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             restore gp

    "lw      $31,0x0030($sp)\n"                           //lw      $ra,0x0014($sp)         restore ra
    "lw      $22,0x0034($sp)\n"                           //lw      $s6,0x0018($sp)         restore s6
    "addiu   $sp,$sp,0x0038\n"                            //addiu   $sp,$sp,0x38
    :
    : "r"(fw_tap_ident), "r"(fw_tap_table), "r"(pFunction), "r"(p0), "r"(p1), "r"(p2));
}

dword exTAP_CallFirmware12(void *pFunction, dword p0, dword p1, dword p2, dword p3, dword p4, dword p5, dword p6, dword p7, dword p8, dword p9, dword p10, dword p11)
{
    // The function has to be implemented in assembler in order to
    // gain full control over register usage.
    // The firmware makes use of the $gp register which contains
    // a different value when running in TAP context.
    __asm__ __volatile__ (
    "addiu   $sp,$sp,0xffc4\n"                            //addiu   $sp,$sp,-0x3c
    "sw      $31,0x0034($sp)\n"                           //sw      $ra,0x0014($sp)         save ra
    "sw      $22,0x0038($sp)\n"                           //sw      $s6,0x0018($sp)         save s6

    "or      $15,%0,$00\n"                                //or      $t7,tap_ident,$00       ptr to tap_ident
    "or      $22,%1,$00\n"                                //or      $s6,tap_table,$00       ptr to tap_table

    "or      $08,$00,%2\n"                                //or      $t0,$00,pFunction       beware of the order here ...
    "or      $04,$00,%3\n"                                //or      $a0,$00,p0
    "or      $05,$00,%4\n"                                //or      $a1,$00,p1
    "or      $06,$00,%5\n"                                //or      $a2,$00,p2
    "lw      $07, 0x44+0x14($sp)\n"                       //
    "sw      $07, 0x10($sp)\n"                            //p4
    "lw      $07, 0x44+0x18($sp)\n"                       //
    "sw      $07, 0x14($sp)\n"                            //p5
    "lw      $07, 0x44+0x1c($sp)\n"                       //
    "sw      $07, 0x18($sp)\n"                            //p6
    "lw      $07, 0x44+0x20($sp)\n"                       //
    "sw      $07, 0x1c($sp)\n"                            //p7
    "lw      $07, 0x44+0x24($sp)\n"                       //
    "sw      $07, 0x20($sp)\n"                            //p8
    "lw      $07, 0x44+0x28($sp)\n"                       //
    "sw      $07, 0x24($sp)\n"                            //p9
    "lw      $07, 0x44+0x2c($sp)\n"                       //
    "sw      $07, 0x28($sp)\n"                            //p10
    "lw      $07, 0x44+0x30($sp)\n"                       //
    "sw      $07, 0x2c($sp)\n"                            //p11

    "lw      $07, 0x44+0x10($sp)\n"                       //$a3     p3

    "lw      $15,0x0000($15)\n"                           //lw      $t7,0x0000($t7)         get tap_ident
    "sll     $15,$15,0x05\n"                              //sll     $t7,$t7,0x05            tap_ident * 32
    "addu    $22,$22,$15\n"                               //addu    $s6,$s6,$t7             offset to this taps tap_table

    "lw      $03,0x0000($22)\n"                           //lw      $v1,0x0000($s6)         get firmware gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             set gp

    "jal     $08\n"                                       //jal     $t0                     call function(p0, p1, p2, p3)

    "lw      $03,0x0004($22)\n"                           //lw      $v1,0x0004($s6)         get tap gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             restore gp

    "lw      $31,0x0034($sp)\n"                           //lw      $ra,0x0014($sp)         restore ra
    "lw      $22,0x0038($sp)\n"                           //lw      $s6,0x0018($sp)         restore s6
    "addiu   $sp,$sp,0x003c\n"                            //addiu   $sp,$sp,0x3c
    :
    : "r"(fw_tap_ident), "r"(fw_tap_table), "r"(pFunction), "r"(p0), "r"(p1), "r"(p2));
}

dword exTAP_CallTap(int ident, void *pFunction, dword p0, dword p1, dword p2, dword p3, dword p4, dword p5, dword p6, dword p7, dword p8, dword p9, dword p10)
{
    // The function has to be implemented in assembler in order to
    // gain full control over register usage.
    // The firmware makes use of the $gp register which contains
    // a different value when running in TAP context.

//save the current tap id
//select the require tap context
//call the function
//restore the $gp
    __asm__ __volatile__ (
    "addiu   $sp,$sp,0xffbc\n"                            //addiu   $sp,$sp,-0x44
    "sw      $31,0x0030($sp)\n"                           //sw      $ra,0x0014($sp)         save ra
    "sw      $22,0x0034($sp)\n"                           //sw      $s6,0x0018($sp)         save s6
    "sw      $23,0x0038($sp)\n"                           //sw      $s7,0x001c($sp)         save s7

    "or      $23,%0,$00\n"                                //or      $s7,tap_ident,$00       ptr to tap_ident
    "or      $22,%1,$00\n"                                //or      $s6,tap_table,$00       ptr to tap_table

//save the current tap id
    "lw      $15,0x0000($23)\n"                           //lw      $t7,0x0000($s7)         get tap_ident
    "sw      $15,0x003c($sp)\n"                           //sw      $t7,0x0020($sp)         save tap_ident
    "sw      $28,0x0040($sp)\n"                           //sw      $gp,0x0024($sp)         save gp

    "or      $15,$00,%2\n"                                //or      $t7,$00,id              beware of the order here ...
    "or      $08,$00,%3\n"                                //or      $t0,$00,pFunction
    "or      $04,$00,%4\n"                                //or      $a0,$00,p0
    "or      $05,$00,%5\n"                                //or      $a1,$00,p1
    "lw      $06, 0x4c+0x10($sp)\n"                       //$a2     p2

    "lw      $07, 0x4c+0x18($sp)\n"                       //
    "sw      $07, 0x10($sp)\n"                            //p4
    "lw      $07, 0x4c+0x1c($sp)\n"                       //
    "sw      $07, 0x14($sp)\n"                            //p5
    "lw      $07, 0x4c+0x20($sp)\n"                       //
    "sw      $07, 0x18($sp)\n"                            //p6
    "lw      $07, 0x4c+0x24($sp)\n"                       //
    "sw      $07, 0x1c($sp)\n"                            //p7
    "lw      $07, 0x4c+0x28($sp)\n"                       //
    "sw      $07, 0x20($sp)\n"                            //p8
    "lw      $07, 0x4c+0x2c($sp)\n"                       //
    "sw      $07, 0x24($sp)\n"                            //p9
    "lw      $07, 0x4c+0x30($sp)\n"                       //
    "sw      $07, 0x28($sp)\n"                            //p10

    "lw      $07, 0x4c+0x14($sp)\n"                       //$a3     p3

//set the new tap id
    "sw      $15,0x0000($23)\n"                           //sw      $t7,0x0000($s7)         set tap_ident

    "sll     $15,$15,0x05\n"                              //sll     $t7,$t7,0x05            tap_ident * 32
    "addu    $22,$22,$15\n"                               //addu    $s6,$s6,$t7             offset to this taps tap_table

    "lw      $03,0x0004($22)\n"                           //lw      $v1,0x0004($s6)         get tap gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             set gp

    "jal     $08\n"                                       //jal     $t0                     call function(p0, p1, p2, p3)

    "lw      $03,0x0040($sp)\n"                           //lw      $v1,0x0040($sp)         get original gp
    "or      $28,$03,$00\n"                               //or      $gp,$v1,$00             restore gp

    "lw      $15,0x003c($sp)\n"                           //lw      $t7,0x0040($sp)         get tap_ident
    "sw      $15,0x0000($23)\n"                           //sw      $t7,0x0000($s7)         restore tap_ident

    "lw      $23,0x0038($sp)\n"                           //lw      $s7,0x001c($sp)         restore s7
    "lw      $22,0x0034($sp)\n"                           //lw      $s6,0x0018($sp)         restore s6
    "lw      $31,0x0030($sp)\n"                           //lw      $ra,0x0014($sp)         restore ra
    "addiu   $sp,$sp,0x0044\n"                            //addiu   $sp,$sp,0x44
    :
    : "r"(fw_tap_ident), "r"(fw_tap_table), "r"(ident), "r"(pFunction), "r"(p0), "r"(p1));
}


//----------------------------------------------------------------------------
//can be in 3 states
//EXTAPERR_ALREADY_PATCHED - correctly patched
//EXTAPERR_NOT_PATCHED     - unpatched
//EXTAPERR_BAD_MATCH       - neither
int exTAP_isPatched(type_patch *patch, int *index)
{
    int i,j;
    int match;

    //search though the list looking for a sysid/version match
    if (index) *index = 0;
    match = 0;
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) && (patch[j].revision == _appl_version)) {
            match = 1;
            break;
        }
        j++;
    }
    if (!match) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
        TAP_Print("\n");
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }
    if (index) *index = j;

    //check if unpatched
    for (i=0; i<patch[j].count; i++) {
        if (*(dword *)(patch[j].info[i].addr) == *(dword *)(patch[j].info[i].from)) {
            if (i == (patch[j].count-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is not patched: 0x%08x", __func__, patch[j].info[0].addr);
#endif
                return EXTAPERR_NOT_PATCHED;
            }
        }
        else {
            break;
        }
    }

    //check if firmware is already patched
    for (i=0; i<patch[j].count; i++) {
        if (*(dword *)(patch[j].info[i].addr) == *(dword *)(patch[j].info[i].to)) {
            if (i == (patch[j].count-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is already patched: 0x%08x", __func__, patch[j].info[0].addr);
#endif
                return EXTAPERR_ALREADY_PATCHED;
            }
        }
        else {
            break;
        }
    }

    return EXTAPERR_BAD_MATCH;
}

int exTAP_ApplyPatch(type_patch *patch)
{
    int i;
    int index;
    int ret;

    ret = exTAP_isPatched(patch, &index);
    if (ret == EXTAPERR_NOT_PATCHED) {
        //apply patch
        for (i=0; i<patch[index].count; i++) {
            memcpy((byte *)patch[index].info[i].addr, patch[index].info[i].to, 4);
        }
        ret = EXTAPERR_NONE;
    }
    return ret;
}

int exTAP_RemovePatch(type_patch *patch)
{
    int i;
    int index;
    int ret;

    ret = exTAP_isPatched(patch, &index);
    if (ret == EXTAPERR_ALREADY_PATCHED) {
        //apply patch
        for (i=0; i<patch[index].count; i++) {
            memcpy((byte *)patch[index].info[i].addr, patch[index].info[i].from, 4);
        }
        ret = EXTAPERR_NONE;
    }
    return ret;
}


int exTAP_isPatched2(type_patch2 *patch, dword addr, int *index)
{
    int i,j;
    int match;

    if (index) *index = 0;
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) || (patch[j].sysid == 0xffffffff)) {
            if ((patch[j].revision == _appl_version) || (patch[j].revision == -1)) {
                if ((patch->addr == addr) || (patch->addr == -1) || (addr == -1)) {
                    if (is_firmware(patch->addr)) addr = patch->addr;

                    //check if unpatched
                    match = 1;
                    for (i=0; i<patch[j].length; i++) {
                        if (*(byte *)(addr+i) != patch[j].from[i]) {
                            match = 0;
                        }
                    }
                    if (match) {
#ifdef exTAPdebug
//                        TAP_Print("\n%s(), Firmware is not patched: 0x%08x", __func__, addr);
#endif
                        if (index) *index = j;
                        return EXTAPERR_NOT_PATCHED;
                    }

                    //check if patched
                    match = 1;
                    for (i=0; i<patch[j].length; i++) {
                        if (*(byte *)(addr+i) != patch[j].to[i]) {
                            match = 0;
                        }
                    }
                    if (match) {
#ifdef exTAPdebug
//                        TAP_Print("\n%s(), Firmware is already patched: 0x%08x", __func__, addr);
#endif
                        if (index) *index = j;
                        return EXTAPERR_ALREADY_PATCHED;
                    }
                }
            }
        }
        j++;
    }
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
    TAP_Print("\n");
#endif
    return EXTAPERR_BAD_FIRMWARE;
}




int exTAP_ApplyPatch2(type_patch2 *patch, dword addr, int *id)
{
    int i,j;
    int match;

    //search though the list looking for a sysid/version match
    j = 0;
    while (patch[j].sysid) {
        //check firmware version
        if ((patch[j].sysid == fw_sysid) || (patch[j].sysid == 0xffffffff)) {
            if ((patch[j].revision == _appl_version) || (patch[j].revision == -1)) {
                if ((patch->addr == addr) || (patch->addr == -1) || (addr == -1)) {
                    if (is_firmware(patch->addr)) addr = patch->addr;

                    //check if patched data matches original firmware
                    match = 1;
                    for (i=0; i<patch[j].length; i++) {
                        if (*(byte *)(addr+i) != patch[j].from[i]) {
                            match = 0;
                        }
                    }

                    if (match) {
                        //save original data
//                        memcpy(patch[j].org, (byte *)addr, patch[j].length);
                        *id = j;

                        //apply patch
                        memcpy((byte *)addr, patch[j].to, patch[j].length);
                        return EXTAPERR_NONE;
                    }
                }
            }
        }
        j++;
    }
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
    TAP_Print("\n");
#endif
    return EXTAPERR_BAD_FIRMWARE;
}

int exTAP_RemovePatch2(type_patch2 *patch, dword addr)
{
    int i;
    int match;

    if (patch->sysid) {
        //check firmware version
        if ((patch->sysid == fw_sysid) || (patch->sysid == 0xffffffff)) {
            if ((patch->revision == _appl_version) || (patch->revision == -1)) {
                if ((patch->addr == addr) || (patch->addr == -1)|| (addr == -1)) {
                    if (is_firmware(patch->addr)) addr = patch->addr;

                    //check if firmware is already patched
                    match = 1;
                    for (i=0; i<patch->length; i++) {
                        if (*(byte *)(addr+i) != patch->to[i]) {
                            match = 0;
                        }
                    }

                    if (match) {
                        //apply patch
                        memcpy((byte *)addr, patch->from, patch->length);
                        return EXTAPERR_NONE;
                    }
                }
            }
        }
    }
#ifdef exTAPdebug
    TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
    TAP_Print("\n");
#endif
    return EXTAPERR_BAD_FIRMWARE;
}


int exTAP_ApplyPatch3(dword addr, byte *from, byte *to, int length)
{
    int i;

    //check if firmware is already patched
    for (i=0; i<length; i++) {
        if (*(byte *)(addr+i) == to[i]) {
            if (i == (length-1)) {
#ifdef exTAPdebug
                TAP_Print("\n%s(), Firmware is already patched: 0x%08x", __func__, addr);
#endif
                return EXTAPERR_ALREADY_PATCHED;
            }
        }
        else {
            break;
        }
    }

    //check if original firmware matches expected data
    for (i=0; i<length; i++) {
       if (*(byte *)(addr+i) != from[i]) {
#ifdef exTAPdebug
            TAP_Print("\n%s(), Original firmware does not match expected: 0x%08x", __func__, addr+i);
#endif
            return EXTAPERR_BAD_MATCH;
        }
    }

    //apply patch
    memcpy((byte *)addr, to, length);
    return EXTAPERR_NONE;
}

//----------------------------------------------------------------------------
//
// TAP Load function
//
// this function installs a tap
//
int exTAP_TAP_Load(char *filename)
{
    int ret;
    volatile dword tapIndex = 0;
    type_TAPProcess *TAPProcess;

//    if ((fw_tap_load  == 0) || (fw_tap_load_data0 == 0) || (fw_tap_load_data1 == 0) || (fw_tap_load_data2 == 0)) {
    if ((fw_tap_load  == 0) || (fw_tap_load_data0 == 0) || (fw_tap_load_data2 == 0)) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    //deadbeef claims fw_tap_index can get overwritten - so it does ...
    // store the current TAP index
    tapIndex = *(dword *)fw_tap_ident;

    //this should be the tap's current dir
//    *fw_tap_load_data0 = *fw_tap_load_data1;                                      //"==/ProgramFiles" ???
    TAPProcess = (type_TAPProcess *)(fw_tap_table + ((*(dword *)fw_tap_ident)*32));
    *fw_tap_load_data0 = (dword)TAPProcess->currentDir;

    ret = exTAP_CallFirmware(fw_tap_load, (dword)filename, 0,0,0, 0,0,0,0,0,0,0);

    //now restore the fw current dir
    *fw_tap_load_data0 = *fw_tap_load_data2;

    // restore the TAP index which has been overwritten by fw_tap_load
    *(dword *)fw_tap_ident = tapIndex;

    return ret;     //the tap load address, 0=fail,
}

//----------------------------------------------------------------------------
//
// TAP Shutdown function
//
// this function shuts down the box
//
#define FW_SHUTDOWN_TASK        0xef00          //the shutdown task id

int exTAP_Shutdown(void)
{
    if (fw_add_task_queue == 0) {
#ifdef exTAPdebug
        TAP_Print("\n%s(), Unsupported firmware: sysid:%d, version:%04x", __func__, fw_sysid, _appl_version);
#endif
        return EXTAPERR_BAD_FIRMWARE;
    }

    exTAP_CallFirmware((void *)fw_add_task_queue, FW_SHUTDOWN_TASK, 0x0, 0,0, 0,0,0,0,0,0,0);       //task_ef00

    return 0;
}

//----------------------------------------------------------------------------
