#include <tap.h>
#include "exTap.h"

//----------------------------------------------------------------------------
int exTAP_GetPIPPosition(void);

//----------------------------------------------------------------------------
//
//this code returns the current position of a firmware generated pip: (12.88 only)
//0=off/top right, 1=bottom right, 2=bottom left, 3=top left
//
int exTAP_GetPIPPosition(void)
{
    type_etc_structure *etc;
    int pip_status;

    if (fw_etc_structure == 0) {
        return EXTAPERR_BAD_FIRMWARE;
    }
    etc = (type_etc_structure *)*(dword *)fw_etc_structure;
    pip_status = (etc->byte_13 >> 3) & 0x3;

//    TAP_Print("\npip_status = %x", pip_status);
    return pip_status;
}

//----------------------------------------------------------------------------
