#include <tap.h>
#include "exTap.h"

//----------------------------------------------------------------------------
int exTAP_GetUTCTime(word *mjd, byte *hour, byte *minute);
dword exTAP_UTCtoLocalTime(dword utc);

//-----------------------------------------------------------------------------
//
//
//
int exTAP_GetUTCTime(word *mjd, byte *hour, byte *minute)
{
    if (fw_utc_time == 0) {
        return EXTAPERR_BAD_FIRMWARE;
    }

    *mjd = fw_utc_time->mjd;
    *hour = fw_utc_time->hour;
    *minute = fw_utc_time->minute;
    return 0;
}

//
//
//
dword exTAP_UTCtoLocalTime(dword utc)
{
    if (fw_utctolocal_time == 0) {
        return EXTAPERR_BAD_FIRMWARE;
    }

    return exTAP_CallFirmware(fw_utctolocal_time, utc,  0,0,0, 0,0,0,0,0,0,0);
}
//---------------------------------------------------------------------------
