#ifndef _INSTRUCTIONS_H__
#define _INSTRUCTIONS_H__

typedef struct {
    char SearchPattern[200];
    char SearchMask[200];
    unsigned long StartAddress;
    unsigned long EndAddress;
    int EntryPointOffset;
    int SearchForPrevADDIUSP;
}type_pattern;


extern type_pattern pattern_fw_TAP_GetCurrentEvent;
extern type_pattern pattern_fw_TAP_GetSignalLevel;
extern type_pattern pattern_fw_TAP_GetSystemProc;
extern type_pattern pattern_fw_TAP_KbHit;
extern type_pattern pattern_fw_appl_version;
extern type_pattern pattern_fw_appl_version2;
extern type_pattern pattern_fw_appl_version3;
extern type_pattern pattern_fw_add_task_queue;
extern type_pattern pattern_fw_ioctl;

extern type_pattern pattern_fw_afd;
extern type_pattern pattern_fw_channel_scale;
extern type_pattern pattern_fw_channel_scale2;
extern type_pattern pattern_fw_DbgSi_LoadDmx;
extern type_pattern pattern_fw_display_func;
extern type_pattern pattern_fw_enable_tshift;
extern type_pattern pattern_fw_epg_highlighted_event;
extern type_pattern pattern_fw_epg_highlighted_event2;
extern type_pattern pattern_fw_epg_refresh;
extern type_pattern pattern_fw_epgstck_patch;
extern type_pattern pattern_fw_event_alloc;
extern type_pattern pattern_fw_event_delete;
extern type_pattern pattern_fw_event_delete2;
extern type_pattern pattern_fw_fChangePlaybackPos;
extern type_pattern pattern_fw_findfirst;
extern type_pattern pattern_fw_get_channel_info;
extern type_pattern pattern_fw_get_channel_info2;
extern type_pattern pattern_fw_get_genre_str;
extern type_pattern pattern_fw_grab_screen_image;
extern type_pattern pattern_fw_hdd_move;
extern type_pattern pattern_fw_is_recording;
extern type_pattern pattern_fw_key_map_patch;
extern type_pattern pattern_fw_mheg_disable;
extern type_pattern pattern_fw_mheg_entry;
extern type_pattern pattern_fw_mheg_entry2;
extern type_pattern pattern_fw_os_free;
extern type_pattern pattern_fw_pcr1_pid;
extern type_pattern pattern_fw_process_dsmcc;
extern type_pattern pattern_fw_process_eit;
extern type_pattern pattern_fw_process_eit2;
extern type_pattern pattern_fw_process_eit3;
extern type_pattern pattern_fw_process_tdt;
extern type_pattern pattern_fw_process_tot;
extern type_pattern pattern_fw_process_tot2;
extern type_pattern pattern_fw_process_tot3;
extern type_pattern pattern_fw_sequence_header;
extern type_pattern pattern_fw_set_wss;
extern type_pattern pattern_fw_shutdown_irq_disable;
extern type_pattern pattern_fw_shutdown_irq_enable;
extern type_pattern pattern_fw_shutdown_task;
extern type_pattern pattern_fw_shutdown_task2;
extern type_pattern pattern_fw_StartRecord;
extern type_pattern pattern_fw_StartRecord2;
extern type_pattern pattern_fw_stop_tshift;
extern type_pattern pattern_fw_tap_load;
extern type_pattern pattern_fw_tap_load2;
extern type_pattern pattern_fw_tap_load_data1;
extern type_pattern pattern_fw_tap_load_data1_2;
extern type_pattern pattern_fw_translate_and_display;
extern type_pattern pattern_fw_ts_struct1;
extern type_pattern pattern_fw_ts_struct2;
extern type_pattern pattern_fw_tshift_block_offset;
extern type_pattern pattern_fw_twinkle;
extern type_pattern pattern_fw_utctolocal_time;

extern type_pattern pattern_fw_flash;
extern type_pattern pattern_fw_timer;
#endif
